import UserService from '@/services/UserService';
import { defineStore } from 'pinia';
import { StorageLike } from 'pinia-plugin-persistedstate';
import SecureLS from 'secure-ls';

const ls = new SecureLS({
    isCompression: false,
    encryptionSecret: '38c31684-d00d-30dc-82e0-fad9eec46d1d',
})
const st: StorageLike = {
    setItem(key: string, value: string) {
        ls.set(key, value);
    },
    getItem(key: string): string | null {
        return ls.get(key);
    },
}
export const userStore = defineStore('user', {
    state:()=>({
        token:'' as string,
        userInfo:{} as any
    }),
    getters: {
        getUserToken: (state) => {
          return state.token;
        },
        getUser: (state) => {
          return state.userInfo;
        },
    },
    actions:{
        async setUserLoginAsync(userId:number){
            try {
                let response = await UserService.LoginAsync(userId)
                if (response.data.resultCode == 1) {
                    this.token = response.data.data.token
                    this.userInfo = response.data.data
                    return true
                }
            } catch (error) {}
            return false
        }
    },
    persist: {
        storage: st,
    }
});